<?php /**
	   * The admin-specific functionality of the plugin.
	   *
	   * This class handles all the admin-related functionality for the Eimskip plugin.
	   * It includes settings, menus, and other admin-specific features.
	   *
	   * @link       smartmedia.is
	   * @since      1.0.0
	   * @package    Tvgexpress
	   * @subpackage Tvgexpress/admin
	   */
class Postboxes {

	public $boxes = array(
		array(
			'postboxId' => 'DROPPN1AGI',
			'name'      => 'N1 Ægissíða',
			'address'   => 'N1 -Ægissíða 102',
			'postcode'  => '107',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1AKR',
			'name'      => 'N1 Akranesi',
			'address'   => 'N1-Þjóðbraut 9',
			'postcode'  => '300',
			'town'      => 'Akranes',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1AKU',
			'name'      => 'N1 Akureyri',
			'address'   => 'N1-Leiruvegi',
			'postcode'  => '600',
			'town'      => 'Akureyri',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1ART',
			'name'      => 'N1 Ártúnsbrekku',
			'address'   => 'N1-Ártúnshöfða',
			'postcode'  => '110',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1BHO',
			'name'      => 'N1 Bíldshöfða',
			'address'   => 'N1-Bíldshöfða 2',
			'postcode'  => '110',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1BNE',
			'name'      => 'N1 Borgarnes',
			'address'   => 'N1-Brúartorg 1',
			'postcode'  => '310',
			'town'      => 'Borgarnes',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1BOR',
			'name'      => 'N1 Borgartúni',
			'address'   => 'N1-Borgartúni 39',
			'postcode'  => '105',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1BRE',
			'name'      => 'N1 Skógarseli',
			'address'   => 'N1-Skógarseli 10',
			'postcode'  => '109',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1FOS',
			'name'      => 'N1 Fossvogi',
			'address'   => 'N1-Kringlumýrarbraut 100',
			'postcode'  => '108',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1GVO',
			'name'      => 'N1 Grafarvogur',
			'address'   => 'N1-Gagnvegur 2',
			'postcode'  => '112',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1HAH',
			'name'      => 'N1 Háholt Mosfellsbær',
			'address'   => 'N1-Háholti 2',
			'postcode'  => '270',
			'town'      => 'Mosfellsbæ',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1HRI',
			'name'      => 'N1 Hringbraut',
			'address'   => 'N1-Hringbraut 12',
			'postcode'  => '101',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1HVE',
			'name'      => 'N1 Hveragerði',
			'address'   => 'N1-Breiðumörk 1',
			'postcode'  => '810',
			'town'      => 'Hveragerði',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1KEF',
			'name'      => 'N1 Keflavík',
			'address'   => 'N1-Hafnargata 86',
			'postcode'  => '230',
			'town'      => 'Reykjanesbær',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1LAE',
			'name'      => 'N1 Lækjargötu hfj.',
			'address'   => 'N1-Lækjargötu 46',
			'postcode'  => '220',
			'town'      => 'Hafnarfirði',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1SEL',
			'name'      => 'N1 Selfossi',
			'address'   => 'N1-Austurvegur 48',
			'postcode'  => '800',
			'town'      => 'Selfoss',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'DROPPN1STO',
			'name'      => 'N1 Stórihjalli Kóp',
			'address'   => 'N1-Stórahjalla 2',
			'postcode'  => '200',
			'town'      => 'Kópavogur',
			'latitude'  => '',
			'longitude' => '',
		),
		/*
		[
			'postboxId' => 'DROPPWCLAU',
			'name' => 'World Class Laugum',
			'address' => 'WC-Sundlaugavegi 30a',
			'postcode' => '105',
			'town' => 'Reykjavík',
			'latitude' => '',
			'longitude' => ''
		],
		[
			'postboxId' => 'DROPPWCNES',
			'name' => 'World Class Seltjarnarnesi',
			'address' => 'WC-Suðurströnd 8',
			'postcode' => '170',
			'town' => 'Seltjarnarnesi',
			'latitude' => '',
			'longitude' => ''
		],
		[
			'postboxId' => 'DROPPWCVEL',
			'name' => 'World Class Tjarnavöllum HFJ',
			'address' => 'WC-Tjarnarvellir 7',
			'postcode' => '221',
			'town' => 'Hafnarfirði',
			'latitude' => '',
			'longitude' => ''
		],
		*/
		array(
			'postboxId' => 'DROPPKRING',
			'name'      => 'Kringlan (Þjónustuborð á annarri hæð)',
			'address'   => 'Kringlan',
			'postcode'  => '103',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'BOXXPR104',
			'name'      => 'Box Olís Álfheimum',
			'address'   => 'Box Olís Álfheimum',
			'postcode'  => '104',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
		array(
			'postboxId' => 'BOXXPR170',
			'name'      => 'Box Hagkaup Seltjarnarnesi',
			'address'   => 'Box Hagkaup Seltjarnarnesi',
			'postcode'  => '170',
			'town'      => 'Seltjarnarnesi',
			'latitude'  => '',
			'longitude' => '',
		),
		/*
		[
			'postboxId' => 'BOXXPR210',
			'name' => 'Box Hagkaup Garðabæ',
			'address' => 'Box Hagkaup Garðabæ',
			'postcode' => '210',
			'town' => 'Garðabær',
			'latitude' => '',
			'longitude' => ''
		],
		*/
		array(
			'postboxId' => 'BOXXPR112',
			'name'      => 'Box Olís Grafarvogi',
			'address'   => 'Box Olís Grafarvogi',
			'postcode'  => '112',
			'town'      => 'Reykjavík',
			'latitude'  => '',
			'longitude' => '',
		),
	);
	/**
	 * Get By Id
	 *
	 * @since    1.0.0
	 * @param string $id id of postbox.
	 */
	public function getById( $id ) {
		foreach ( $this->boxes as $box ) {
			if ( $id === $box->postboxId ) {
				return $box;
			}
		}
		return false;
	}
	/**
	 * Get Boxes
	 *
	 * @since    1.0.0
	 */
	public function getBoxes() {
		return $this->boxes;
	}
}
